"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = parseAndFindVarsInProgram;

var _parser = require("@babel/parser");

var _traverse = _interopRequireDefault(require("@babel/traverse"));

var _pushUniqueVariable = _interopRequireDefault(require("./pushUniqueVariable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function parseAndFindVarsInProgram(program) {
  var usedVariables = [];
  var definedVariables = [];
  var code = (0, _parser.parse)(program, {
    plugins: ['objectRestSpread']
  });
  (0, _traverse.default)(code, {
    Program: function Program(path) {
      var varsDefined = Object.keys(path.scope.bindings);
      var varsInGlobal = Object.keys(path.scope.globals);
      usedVariables = (0, _pushUniqueVariable.default)(usedVariables, varsInGlobal);
      definedVariables = (0, _pushUniqueVariable.default)(definedVariables, varsDefined);
    }
  });
  return {
    used: usedVariables,
    defined: definedVariables
  };
}