"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildVariable = buildVariable;
exports.findVariable = findVariable;

function buildVariable(name, startCoord, endCoord) {
  return {
    value: name,
    loc: {
      start: {
        line: startCoord[0],
        column: startCoord[1]
      },
      end: {
        line: endCoord[0],
        column: endCoord[1]
      }
    }
  };
}

function findVariable(name, location, source) {
  var line = location.start.line;
  var valueStartsAt = location.start.column - 1;
  var columnStart = valueStartsAt + source[0].substring(valueStartsAt).indexOf(name);
  var columnEnd = columnStart + name.length;
  return buildVariable(name, [line, columnStart], [line, columnEnd]);
}