"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = findVariablesInTemplate;

var _pugLexer = _interopRequireDefault(require("@startupjs/pug-lexer"));

var _visitors = _interopRequireDefault(require("./visitors"));

var _State = _interopRequireDefault(require("./State"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function findVariablesInTemplate(template) {
  if (template) {
    var tokens = (0, _pugLexer.default)(template);
    var state = new _State.default();
    tokens.forEach(function (token) {
      return (0, _visitors.default)(state, token, template);
    });
    return state.getVariables();
  }

  return [];
}